optic-distribution-system2/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index');

Auth::routes();
//Route User
Route::get('/User/datatable', 'UserController@datatable')->middleware('auth');

//Route Category
Route::get('/Category/datatable', 'CategoryController@datatable')->middleware('auth');
Route::patch('/Category/json', 'CategoryController@getItemJson')->middleware('auth');
Route::get('/Category/jsonSelect', 'CategoryController@getItemJsonSelect2')->middleware('auth');

//Route SubCategory
Route::get('/SubCategory/datatable/{id}', 'SubCategoryController@datatable')->middleware('auth');
Route::patch('/SubCategory/json', 'SubCategoryController@getItemJson')->middleware('auth');
Route::get('/SubCategory/jsonSelect', 'SubCategoryController@getItemJsonSelect2')->middleware('auth');

//Route Optic
Route::get('/Optic/datatable', 'OpticController@datatable')->middleware('auth');
Route::patch('/Optic/json', 'OpticController@getOpticJson')->middleware('auth');

//Route Item
Route::get('/Item/datatable', 'ItemController@datatable')->middleware('auth');
Route::patch('/Item/json', 'ItemController@getItemJson')->middleware('auth');
Route::patch('/Item/jsonitemWithStock', 'ItemController@getItemWithStockJson')->middleware('auth');
Route::get('/Item/jsonSelect', 'ItemController@getItemJsonSelect2')->middleware('auth');

//Route Order
Route::get('/Order/datatable', 'SalesController@datatable')->middleware('auth');
Route::get('/Order/view/{id}', 'SalesController@view')->middleware('auth');
Route::get('/Order/edit/{id}', 'SalesController@edit')->middleware('auth');
Route::get('/Order/retur/{id}', 'SalesController@retur')->middleware('auth');
Route::post('/Order/retur/{id}', 'SalesController@prosesRetur')->middleware('auth');

Route::post('/Order/editSales/{id}', 'SalesController@updateSales')->middleware('auth');


Route::get('/Category/SubCategory/{id}', 'CategoryController@ajax_subcategory')->middleware('auth');
Route::get('/ItemStock/datatable', 'ItemStockController@datatable')->middleware('auth');
Route::get('/Print/{id}', 'PrintController@index')->middleware('auth');
Route::get('/Print/{id}/{id_payment}', 'PrintController@payment')->middleware('auth');
Route::get('/Print/ReturDistributor/{id}', 'PrintController@ReturDistributor')->middleware('auth');


Route::resource('User', 'UserController')->middleware('auth');
Route::resource('Category', 'CategoryController')->middleware('auth');
Route::resource('SubCategory', 'SubCategoryController')->middleware('auth');
Route::resource('Optic', 'OpticController')->middleware('auth');
Route::resource('Item', 'ItemController')->middleware('auth');
//Route::resource('Payment', 'PaymentController')->middleware('auth');
Route::get('Payment/{id}', ["as" => "Payment.index", "uses" => "PaymentController@index"])->middleware('auth');
Route::get('Payment/{id}/datatable', 'PaymentController@datatable')->middleware('auth');
Route::get('Payment/{id}/create', 'PaymentController@create')->middleware('auth');
Route::post('Payment', 'PaymentController@store')->middleware('auth');

Route::resource('Stock', 'ItemStockController')->middleware('auth');
Route::resource('Order', 'SalesController')->middleware('auth');

Route::get('/home', 'HomeController@index')->name('home')->middleware('auth');


Route::get('/Item/test', 'ItemController@test')->middleware('auth');

Route::get('/Stock/updateItemStock/{id}', 'ItemStockController@newStock')->middleware('auth');
Route::get('/Stock/detail/{id}', 'ItemStockController@detailStock')->middleware('auth');
Route::get('/receiveItemStock', 'ItemStockController@receiveStock')->middleware('auth');
Route::get('/Stock/create', 'ItemStockController@receiveStock')->middleware('auth');


Route::get('/Stock/newItemStock/{id}', 'ItemStockController@newStock')->middleware('auth');
Route::get('/receiveItemStock', 'ItemStockController@receiveStock')->middleware('auth');

// report controller
Route::get('/Report/inventoryDatatable', 'ReportController@inventoryDatatable')->middleware('auth');
Route::get('/Report/inventoryLowDatatable', 'ReportController@inventoryLowDatatable')->middleware('auth');
Route::get('/Report/expiryDatatable', 'ReportController@expiryDatatable')->middleware('auth');
Route::get('/Report/salesDatatable', 'ReportController@salesDatatable');
Route::post('/Report/salesDatatable', 'ReportController@salesDatatable');
Route::get('/Report/stokChartJson', 'ReportController@inventoryChartJSON');
Route::get('/Report/salesChartByItemJSON', 'ReportController@salesChartByItemJSON');
Route::get('/Report/salesChartByRevenueJSON', 'ReportController@salesChartByRevenueJSON');
Route::get('/Report/summaryJson', 'ReportController@summaryJson');


Route::get('/Report/inventory', 'ReportController@inventory')->middleware('auth');
Route::get('/Report/inventoryLow', 'ReportController@inventoryLow')->middleware('auth');
Route::get('/Report/sales', 'ReportController@sales')->middleware('auth');
Route::get('/Report/expiry', 'ReportController@expiry')->middleware('auth');

Route::get('/Retur', 'ReturController@index')->middleware('auth');
Route::get('/Retur/Client', 'ReturController@indexClient')->middleware('auth');
Route::get('/Retur/Client/datatable', 'ReturController@datatableClient')->middleware('auth');
Route::get('/Retur/Client/{id}', 'ReturController@viewClient')->middleware('auth');
Route::delete('/Retur/Client/delete/{id}', 'ReturController@destroyClient')->middleware('auth');

Route::get('/Retur/datatable', 'ReturController@datatable')->middleware('auth');
Route::get('/ReturDistributor/create', 'ReturController@createDistributor')->middleware('auth');
Route::post('/ReturDistributor/create', 'ReturController@storeDistributor')->middleware('auth');
Route::get('/ReturDistributor/view/{id}', 'ReturController@viewDistributor')->middleware('auth');
Route::get('/ReturDistributor/edit/{id}', 'ReturController@editDistributor')->middleware('auth');
Route::post('/ReturDistributor/edit/{id}', 'ReturController@updateDistributor')->middleware('auth');
Route::delete('/ReturDistributor/delete/{id}', 'ReturController@destroyDistributor')->middleware('auth');

Route::get('/Report/receivings', 'ReportController@receivings')->middleware('auth');



Route::get('/OpticList/datatable', 'BillingController@datatable')->middleware('auth');
Route::resource('Billing', 'BillingController')->middleware('auth');
Route::patch('/billing/json', 'BillingController@getOpticJson')->middleware('auth');

optic-distribution-system2/app/Optic.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Optic extends Model
{
    protected $primaryKey = 'id';
    protected $table = 'optics';

    public function sale(){
        return $this->hasMany('App\Sale');
      }
    public function getKotaAttribute(){
      return $this->cabang_id == 1 ? 'Kudus' : 'Semarang';
    }
}

optic-distribution-system2/app/Http/Controllers/BillingController.php
<?php

namespace App\Http\Controllers;

use DataTables;
use App\User;
use App\Optic;
use App\Sale;
use Auth;

use Illuminate\Http\Request;
use Route;
use Validator;
use Redirect;
use PDF;

class BillingController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */

    public function __construct()
    {
       $this->middleware('auth');
    }


   public function index()
    {
        return view('billing.index');
    }

    public function getOpticJson(Request $request){
        $optic = Optic::find($request->id);
        
        $sale = Sale::where('optic_id',$request->id)->get();
        $filtered = $sale->filter(function($model){
            return $model->status_pembayaran == "Pending";
        });



        $retVal['optic'] = $optic->toArray();
        $retVal['sales'] = $filtered->toArray();

        return response()->json($retVal);
    }

    public function datatable(){
         $model = Sale::with('optic')->groupBy('optic_id')->get();

         return DataTables::of($model)
                  ->addColumn('action', function(Sale $sale) {
                            if($sale->status_pembayaran == "Pending"){
                                 $retVal = '
                                       <a href="'.url("/CreateInvoice").'/'.$sale->optic_id.'" type="button" class="btn yellow-crusta btn-outline">Billing</a>';
                               }
                               else{
                                $retVal = '';
                               }
                             
                             return $retVal;
                         })
                 ->addColumn('status_pembayaran', function(Sale $sale) {
                           if($sale->status_pembayaran == "Pending"){
                             return $sale->status_pembayaran;
                           }
                           else{
                             return $sale->status_pembayaran;
                           }
                         })
                 ->addColumn('optic_name', function(Sale $sale) {
                    $retVal = $sale->optic->nama;
                    return $retVal;
                 })
                 ->addColumn('status_pembayaran', function(Sale $sale) {
                           if($sale->status_pembayaran == "Pending"){
                             return $sale->status_pembayaran;
                           }
                           else{
                             return $sale->status_pembayaran;
                           }
                         })

                 ->toJson();

        
     }

     



    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {   
        $user     = Auth::user();
        $date     = date("d-m-Y");
        $optic    = new Optic;
        $listOptic = Optic::all();
        return view('billing.create', ['model'=>$optic , 'listOptic'=>$listOptic, 'date' => $date,'user'=>$user]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        
        $invoices   = $request->invoiceNumber;

        
        $optic = Optic::find($request->opticSelect);

        $billingList = array();
        $i=1;
        $total_billing = 0;
        foreach ($invoices as $invoiceID) {
            $sales = Sale::find($invoiceID);
            $billingRow['no'] = $i;
            $billingRow['invoiceID'] = $invoiceID;
            $billingRow['tanggal'] = date('d-m-Y', strtotime($sales->created_at));
            $billingRow['total'] = $sales->total;
            $billingList[]=$billingRow;
            $total_billing = $total_billing + $sales->total;
            $i++;
        }

        $data = [
            'ct'          => $request->ct,
            'jatuh_tempo' => $request->jatuh_tempo,
            'facet'       => $request->facet,
            'tinting'     => $request->tinting,
            'kirim'       => $request->kirim,
            'lain'        => $request->lain,
            'optic'       => $optic,
            'billingList' => $billingList,
            'total_billing' => $total_billing
        ];

        $pdf = PDF::loadView('printTheme.billing',$data);
        return $pdf->setPaper('a4', 'portrait')
                ->download('billing.pdf');


    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $sale = Sale::with('optic')->where('optic_id',$id)->get();
        $filtered = $sale->filter(function($model){
            return $model->status_pembayaran == "Pending";
        });

        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

optic-distribution-system2/resources/views/billing/create.blade.php
@extends('layouts.app')

@component('components.select2Plugin')
@endcomponent

@component('components.toastrNotif')
@endcomponent

@section('content')

<div class="page-content-wrapper">
  <div class="page-content-wrapper">
      <div class="page-content">
          <div class="page-bar">
              <ul class="page-breadcrumb">
                  <li>
                      <i class="icon-home"></i>
                      <a href="{{ url("Order") }}">Manage Order</a>
                      <i class="fa fa-angle-right"></i>
                  </li>
                  <li>
                      <span>Create Billing</span>
                  </li>
              </ul>
          </div>
          <!-- BODY CONTENT -->
          <div class="portlet light bordered">
              <div class="portlet-title">
                  <div class="caption">
                      <i class="icon-equalizer font-red-sunglo"></i>
                      <span class="caption-subject font-red-sunglo bold uppercase">Billing</span>
                      <span class="caption-helper">Create new Billing</span>
                  </div>
                  <div class="tools">
                      <a href="" class="collapse"> </a>
                      <a href="#portlet-config" data-toggle="modal" class="config"> </a>
                      <a href="" class="reload"> </a>
                      <a href="" class="remove"> </a>
                  </div>
              </div>
              <div class="portlet-body form">
                  <!-- BEGIN FORM-->
                    {{ Form::model($model, ['action' => 'BillingController@store','class'=>"form-horizontal"]) }}
                      <div class="form-body" style="padding-top:0px">
                          <h3 class="form-section">Billing Information</h3>
                          <div class="row">
                              <div class="col-md-6">
                                  <div class="form-group">
                                      <label class="control-label col-md-3">Nama pegawai</label>
                                      <div class="col-md-9">
                                          <input type="text" class="form-control" value="{{$user->name}}" readonly>
                                      </div>
                                  </div>
                              </div>
                              <!--/span-->
                              <div class="col-md-6">
                                  <div class="form-group">
                                      <label class="control-label col-md-3">Tanggal Invoice</label>
                                      <div class="col-md-9">
                                          <input type="text" class="form-control" value="{{$date}}" readonly>
                                      </div>
                                  </div>
                              </div>
                              <!--/span-->
                          </div>
                          <!--/row-->

                          <!--/row-->
                          <div class="row" style = "margin-top:10px">
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label class="control-label col-md-3">Cabang</label>
                                    <div class="col-md-9">
                                        <input type="text" class="form-control" value="{{$user->cabang->nama}}" readonly> </div>
                                </div>
                            </div>
                          </div>
                          <h3 class="form-section">Receiver Information</h3>
                          <!--/row-->
                          <div class="row">
                              <div class="col-md-6">
                                  <div class="form-group">
                                      <label class="control-label col-md-3">Optic</label>
                                      <div class="col-md-9">
                                        <select class="form-control select2" data-placeholder="Choose Optic" id="opticSelect" name="opticSelect" tabindex="1">
                                          <option value="-99">Choose Optic</option>
                                          @foreach ($listOptic as $optic)
                                            <option value="{{$optic->id}}">{{$optic->nama}} - {{$optic->kota}}</option>
                                          @endforeach
                                        </select>
                                      </div>
                                  </div>
                              </div>
                              <div class="col-md-6">
                                  <div class="form-group">
                                      <label class="control-label col-md-3">CT</label>
                                      <div class="col-md-9">
                                          <input id="plafonOptic" name="ct" type="textarea" class="form-control" value="">
                                      </div>
                                  </div>
                              </div>
                          </div>

                          <div class="row" style="margin-top:10px">
                              <div class="col-md-6">
                                  <div class="form-group">
                                      <label class="control-label col-md-3">Alamat Optic</label>
                                      <div class="col-md-9">
                                          <input id="alamatOptic" type="textarea" class="form-control" value="" readonly>
                                      </div>
                                  </div>
                              </div>

                              <div class="col-md-6">
                                  <div class="form-group">
                                      <label class="control-label col-md-3">Jatuh Tempo</label>
                                      <div class="col-md-9">
                                          <input id="jatuh_tempo" type="text" class="form-control date-picker" data-date-format="dd-mm-yyyy" name="jatuh_tempo" value="">
                                      </div>
                                  </div>
                              </div>
                              
                          </div>
                          

                          <h3 class="form-section">Invoice</h3>
                          <div class="row table-scrollable">
                            <table class="table table-hover" id="itemSales">
                                <thead>
                                    <tr>
                                        <th> NO </th>
                                        <th> NO. INVOICE </th>
                                        <th> TGL. INVOICE </th>
                                        <th colspan="2"> JUMLAH </th>
                                        <th> Action </th>
                                    </tr>
                                </thead>
                                <tbody>
                                </tbody>
                            </table>
                          </div>
                          

                          <!--/row-->
                      </div>
                    

                      <div class="form-actions right">
                          <button id="submitButton" type="submit" onClick="submit()" class="btn blue">
                              <i class="fa fa-check"></i> Submit</button>
                      </div>
                  <!-- END FORM-->
                  </form>
              </div>
          </div>
          <!-- END BODY CONTENT -->

      </div>
      <!-- END CONTENT -->
  </div>
</div>

@push('scripts')
  <script>

    $( document ).ready(function() {

    $(".select2").select2();
  });


    var idCount = 0;

    $.ajaxSetup({
      headers: {
          'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
      }
    });

    

    $('#opticSelect').on('select2:select', function (e) {
      var data = e.params.data;
      var id = data.id;
      $.ajax({
          url: '{{url("billing")}}/json',
          type: 'PATCH',
          data: {id : id},
          success: function(result) {
            $("#itemSales tbody").empty();
            $("#alamatOptic").val(result.optic.alamat);
            
            var sales = result.sales;
            if (sales.length<1) {
              toastr.error("Optik Tidak Memiliki Pembayaran Pending", "Alert");
            }else{
              var x = 1;
              $.each(result.sales, function (i) {
                var invoiceID = result.sales[i].id;
                var tanggal = result.sales[i].created_at;                  
                var total = result.sales[i].total;

                 var item =
                  "<tr>"+
                    "<td> "+x +"</td>"+
                    "<td> "+invoiceID +"</td>"+
                    "<td> "+tanggal +"</td>"+
                    "<td>Rp.</td>"+
                    "<td> "+total.toLocaleString() +"</td>"+
                    "<td> <input type='checkbox' name='invoiceNumber[]' value='"+invoiceID+"' class='form-control' checked> </td>"+
                  "</tr>";
                $("#itemSales tbody").append(item);
                x++;
              });

              var itemFooter =
                  "<tr>"+
                    "<td colspan='3'> <strong>BIAYA FACET</strong> </td>"+"<td>Rp.</td>"+"<td colspan='2'> <input type='text' name='facet' class='form-control'> </td>"+
                  "</tr>"+
                  "<tr>"+
                    "<td colspan='3'> <strong>BIAYA TINTING</strong> </td>"+"<td>Rp.</td>"+"<td colspan='2'> <input type='text' name='tinting' class='form-control'> </td>"+
                  "</tr>"+
                  "<tr>"+
                    "<td colspan='3'> <strong>BIAYA KIRIM</strong> </td>"+"<td>Rp.</td>"+"<td colspan='2'> <input type='text' name='kirim' class='form-control'> </td>"+
                  "</tr>"+
                  "<tr>"+
                    "<td colspan='3'> <strong>BIAYA LAIN LAIN</strong> </td>"+"<td>Rp.</td>"+"<td colspan='2'> <input type='text' name='lain' class='form-control'> </td>"+
                  "</tr>";
                $("#itemSales tbody").append(itemFooter);

             
            }

            
            
          },
          error: function (xhr, status, errorThrown) {
            
          }
      });
    });

    




  </script>
  <script src="//cdnjs.cloudflare.com/ajax/libs/numeral.js/2.0.6/numeral.min.js"></script>
@endpush

@endsection

optic-distribution-system2/resources/views/billing/index.blade.php
@extends('layouts.app')

@component('components.toastrNotif')
@endcomponent

@component('components.datatablePlugin')
@endcomponent

@section('content')

<div class="page-content-wrapper">

    <div class="page-content">
        <h2 class="page-title"> List Order
            <small>detail & manage order</small>
        </h2>

        <!-- BODY CONTENT -->
        <div class="row">
            <div class="col-md-12">
              <?php if(session('errMessage')) {?>
                  <div class="alert alert-danger">
                    {{session('errMessage')}}
                  </div>
              <?php } ?>


              <div class="portlet light ">
                  
                  <div class="portlet-body">
                    @component('components.npmDatatable')
                      @slot('idTable')
                        sales
                      @endslot
                      <thead>
                      <tr>
                        <th>
                          Optic
                        </th>
                        <th>
                          Status Pembayaran
                        </th>
                        <th>
                          Action
                        </th>
                      </tr>
                      </thead>
                    @endcomponent
                  </div>
                </div>
            </div>

        </div>
        <!-- END BODY CONTENT -->

    </div>
    <!-- END CONTENT -->
</div>

@endsection

@push('scripts')
<script>

$(function() {
    @if(session('successMsg'))
      toastr.success("{{session('successMsg')}}", "Success")
    @endif

    var table = $('#sales').DataTable({
        processing: true,
        serverSide: true,
        ajax: '{{ url("OpticList") }}/datatable',
        order: [[ 1, "desc" ]],
        columns: [
            { data: 'optic_name', name: 'optic_name' },
            { data: 'status_pembayaran', name: 'status_pembayaran' },
            { data: 'action', name: 'action',Sortable: "false"}
        ],
        columnDefs: [
          { className: "dt-body-center", "targets": [ 0, 1] },
          
          
        ],
        fnDrawCallback: function (oSettings) {

              $("[data-toggle='confirmation']").confirmation({
                singleton: true,
                onConfirm:function(){
                  var myElement = $(this).closest('.popover').prev();
                  var id        = myElement.context.getAttribute('data-id');

                  $.ajax({
                      url: '{{url("Order")}}/'+id,
                      type: 'DELETE',
                      data: {_token: '{{csrf_token()}}'},
                      success: function(result) {
                        table.ajax.reload();

                        toastr.success("Order Berhasil dihapus", "Success");

                        toastr.options = {
                          "closeButton": false,
                          "debug": false,
                          "newestOnTop": false,
                          "progressBar": false,
                          "positionClass": "toast-top-right",
                          "preventDuplicates": false,
                          "onclick": null,
                          "showDuration": "300",
                          "hideDuration": "1000",
                          "timeOut": "5000",
                          "extendedTimeOut": "1000",
                          "showEasing": "swing",
                          "hideEasing": "linear",
                          "showMethod": "fadeIn",
                          "hideMethod": "fadeOut"
                        }
                      }
                  });

                }
              });
            }
    });
});


</script>
<script src="//cdnjs.cloudflare.com/ajax/libs/numeral.js/2.0.6/numeral.min.js"></script>
<script src="{{asset("assets/global/plugins/bootstrap-confirmation/bootstrap-confirmation.min.js")}}" type="text/javascript"></script>
<script src="{{asset("assets/pages/scripts/ui-confirmations.min.js")}}" type="text/javascript"></script>

@endpush